#define WIN32_LEAN_AND_MEAN
#define _WIN32_WINNT 0x500
#define COBJMACROS
#include <windows.h>
#include <stdio.h>
#include <shlobj.h>
#include "shellbrowser.h"
#include "objbase.h"
#include "resid.h"

void fatal_error(int msgid, char *console_msg)
{
	MessageBox(NULL, L"Could not start", NULL, MB_OK);  // TODO: resources
	TerminateProcess(GetCurrentProcess(), 1);
}

CRITICAL_SECTION sectionDebug;

FILE *__debug_out;
char guidbuf[100][100];
int guidbuf_pos=0;
const char *__debug_function_name;
const char *__debug_class;

#define CHECK_IID(name) \
	if (IsEqualIID(guid, &IID_##name)) \
	{ \
	wsprintfA(guidbuf[pos], #name " [{%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x}]", \
			guid->Data1, guid->Data2, guid->Data3, guid->Data4[0], guid->Data4[1], \
			guid->Data4[2], guid->Data4[3], guid->Data4[4], guid->Data4[5], \
			guid->Data4[6], guid->Data4[7]); \
	}

char *debugstr_guid(REFGUID guid)
{
	int pos=guidbuf_pos;
	guidbuf_pos = (guidbuf_pos+1)%100;
	CHECK_IID(IShellFolder)
	else CHECK_IID(IShellFolder2)
	else CHECK_IID(IShellView)
	else CHECK_IID(IShellIcon)
	else CHECK_IID(IShellIconOverlay)
	else CHECK_IID(IShellDetails)
	else CHECK_IID(IFolderFilter)
	else CHECK_IID(IInternetSecurityManager)
	else CHECK_IID(IPersist)
	else CHECK_IID(IPersistFolder)
	else CHECK_IID(IPersistFolder2)
	else CHECK_IID(IPersistFolder3)
	else CHECK_IID(IPersistIDList)
	else CHECK_IID(IObjectWithSite)
	else CHECK_IID(IZoneIdentifier)
	else CHECK_IID(IDropTarget)
	else CHECK_IID(IExtractIconA)
	else CHECK_IID(IExtractIconW)
	else CHECK_IID(IBrowserFrameOptions)
	else CHECK_IID(IDataObject)
	else CHECK_IID(IContextMenu)
	else CHECK_IID(IQueryInfo)
	else CHECK_IID(IOleCommandTarget)
	else CHECK_IID(IServiceProvider)
	else CHECK_IID(ICommDlgBrowser)
	else
	wsprintfA(guidbuf[pos], "{%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x}",
		guid->Data1, guid->Data2, guid->Data3, guid->Data4[0], guid->Data4[1],
		guid->Data4[2], guid->Data4[3], guid->Data4[4], guid->Data4[5],
		guid->Data4[6], guid->Data4[7]);
	return guidbuf[pos];
}

void do_print_trace(const char *fmt, ...)
{
	va_list ap;
	va_start(ap, fmt);
	EnterCriticalSection(&sectionDebug);
	fprintf(__debug_out, "%s:%s ", __debug_class, __debug_function_name);
	fflush(__debug_out);
	vfprintf(__debug_out, fmt, ap);
	fflush(__debug_out);
	LeaveCriticalSection(&sectionDebug);
	va_end(ap);
}

void initDebug()
{
	char filename[200];
	wsprintfA(filename, "F:\\browser-out-%08x.txt", GetCurrentProcessId());
	__debug_out = fopen(filename, "w");
	InitializeCriticalSection(&sectionDebug);
}

#include <winternl.h>
typedef DWORD NTSTATUS;
typedef enum _KEY_VALUE_INFORMATION_CLASS {
    KeyValueBasicInformation,
    KeyValueFullInformation,
    KeyValuePartialInformation,
    KeyValueFullInformationAlign64,
    KeyValuePartialInformationAlign64
} KEY_VALUE_INFORMATION_CLASS;

NTSTATUS  (WINAPI *NtOpenKey)(PHANDLE,ACCESS_MASK,const OBJECT_ATTRIBUTES *);
void      (WINAPI *pRtlInitUnicodeString)(PUNICODE_STRING,PCWSTR);
NTSTATUS  (WINAPI *NtQueryValueKey)(HANDLE,const UNICODE_STRING *,KEY_VALUE_INFORMATION_CLASS,void *,DWORD,DWORD *);


void exp_reg()
{
    OBJECT_ATTRIBUTES attr;
    UNICODE_STRING nameW;
	NTSTATUS status;
	char tmp[1024];
    HANDLE hkey;
    DWORD dummy, dummy2;
	DWORD err;
	HKEY hkey2;

	HINSTANCE hNTDLL = GetModuleHandle(L"ntdll");
	NtOpenKey = GetProcAddress(hNTDLL, "NtOpenKey");
	NtQueryValueKey = GetProcAddress(hNTDLL, "NtQueryValueKey");
	pRtlInitUnicodeString = GetProcAddress(hNTDLL, "RtlInitUnicodeString");

	err = RegOpenKeyEx(HKEY_LOCAL_MACHINE, L"Software", 0, KEY_READ|KEY_WOW64_32KEY, &hkey2);
	if (err)
		*(int *)NULL = 0;
	dummy2 = sizeof(tmp);
	RegQueryValueEx(hkey2, L"Test", NULL, &dummy, tmp, &dummy2);

    pRtlInitUnicodeString( &nameW, L"\\Registry\\Machine\\Software" ); //System
	attr.Length = sizeof(attr);
    attr.RootDirectory = 0;
    attr.ObjectName = &nameW;
    attr.Attributes = 0x40;
    attr.SecurityDescriptor = NULL;
	attr.SecurityQualityOfService = NULL;
	status = NtOpenKey( &hkey, KEY_READ|KEY_WOW64_32KEY, &attr );
    if (status != 0/*STATUS_SUCCESS*/)
		*(int *)NULL = 0;

    pRtlInitUnicodeString( &nameW, L"Test" );
	status = NtQueryValueKey( hkey, &nameW, KeyValuePartialInformation, tmp, sizeof(tmp), &dummy );
    if (!status)
    {
		dummy = 0;
    }
	else
		*(int *)NULL = 0;
//    NtClose( hkey );
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    MSG         msg;
//    HACCEL      hAccel;
	HWND        hWnd;


	exp_reg();
	initDebug();
	hShell32 = LoadLibrary(L"shell32");
	if (!hShell32)
		fatal_error(IDS_CANNOT_START, "Loading shell32 failed\n");

	InitCommonControls();
	CoInitializeEx(NULL, COINIT_APARTMENTTHREADED);

	if (FAILED(BROWSER_RegisterClass()))
		fatal_error(IDS_CANNOT_START, "Register class\n");

    hWnd = BROWSER_CreateWindow();

	if (!hWnd)
		fatal_error(IDS_CANNOT_START, "CreateWindow\n");

	ShowWindow(hWnd, SW_SHOW);

	while (GetMessage(&msg, 0, 0, 0))
	{
//		if (!TranslateAccelerator(Globals.hMainWnd, hAccel, &msg) && !IsDialogMessage(Globals.hFindReplaceDlg, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
    }
    return (int)msg.wParam;
}
